function Impalavehicle::onTrigger(%this, %veh, %slot, %val)	//Braking
{
	if(%val)
	{	//brake on
		%veh.braking = 1;

		%veh.hidenode(brakelights_red_0);
		%veh.hidenode(brakelights_red_1);
		%veh.unhidenode(brakelights_red_2);
	}
	else
	{	//brake off
		%veh.braking = 0;

		%veh.hidenode(brakelights_red_2);

		if(%veh.headlightState > 0)
			%veh.unhidenode(brakelights_red_1);

		else
			%veh.unhidenode(brakelights_red_0);
	}
}

function Impalavehicle::headlights(%this, %veh, %directive, %selection)
{
	switch$(%directive)
	{
		case "next":
		%setlights = %veh.headlightState + 1;
		%veh.headlightState = %veh.headlightState + 1;
		
		case "restore":
		%setlights = %veh.headlightState;
		
		case "select":
		%setlights = %selection;
		%veh.headlightState = %selection;
		
		case "off":
		%setlights = 0;
	}
	
	if(%setlights > 2)
	{
		%setlights = 0;
		%veh.headlightState = 0;
	}
	
	switch(%setlights)
	{
		case 0:		//Headlights off
			%veh.mountedLightBot[%this.mountedlightbotmount].setMountedLight(none);
			%veh.unhidenode(headlights_white_0);
			%veh.hidenode(headlights_white_1);
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				%veh.hidenode(brakelights_red_2);
				%veh.hidenode(brakelights_red_1);
				%veh.unhidenode(brakelights_red_0);
			}
		
		case 1:		//Daytime-running lights
			%veh.mountedLightBot[%this.mountedlightbotmount].setMountedLight(none);
			%veh.unhidenode(headlights_white_1);
			%veh.hidenode(headlights_white_0);
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				%veh.hidenode(brakelights_red_2);
				%veh.hidenode(brakelights_red_0);
				%veh.unhidenode(brakelights_red_1);
			}
		
		case 2:		//Full lights including light source
			%veh.mountedLightBot[%this.mountedlightbotmount].setMountedLight(ImpalaHeadLight);
			
			%veh.hidenode(headlights_white_0);
			%veh.unhidenode(headlights_white_1);
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				%veh.hidenode(brakelights_red_2);
				%veh.hidenode(brakelights_red_0);
				%veh.unhidenode(brakelights_red_1);
			}
	}
} //End of headlights


/////////////////////////////////////////////////////////////////////////////////


function Impalavehicle::turnSignal(%this, %veh, %direction)
{
	if (!isObject(%veh)) return;
	//announce("turnSignal with direction " @ %direction @ " and signalMinor " @ %veh.signalMinor);

	if(%direction == 0 || %direction != %veh.signal)	//0 is a signal to turn off
	{	//TURN OFF SIGNAL
		cancel(%veh.turnSignalSchedule);
		%veh.signalMinor = 0;	//this means lights will begin on "turn on" cycle when next used

		%veh.unhideNode(lights_amberR_0);
		%veh.unhideNode(lights_amberL_0);
		%veh.hideNode(lights_amberR_1);
		%veh.hideNode(lights_amberL_1);

	}	//END OF TURN OFF SIGNAL

	%veh.signal = %direction;	//Other functions must know which direction is being used
	if(%direction == 0)	return;



	if(%veh.signalMinor == 0)	//If the signal lights were off before this moment. Turn on
	{
		%veh.signalMinor = 1;	//Switch so that the schedule uses the section below
		if(%direction == 1)		//Right side turn on
		{
			%veh.hideNode(lights_amberR_0);
			%veh.unhideNode(lights_amberR_1);
		}
		else if(%direction == -1)	//Left side turn on
		{
			%veh.hideNode(lights_amberL_0);
			%veh.unhideNode(lights_amberL_1);
		}
		else //Hazard lights on
		{
			%veh.hideNode(lights_amberR_0);
			%veh.unhideNode(lights_amberR_1);
			%veh.hideNode(lights_amberL_0);
			%veh.unhideNode(lights_amberL_1);
		}
	}
	else	//Signal lights were on before this instant. Turn off
	{
		%veh.signalMinor = 0;	//Switch so that the schedule uses the section above
		if(%direction == 1)		//Right side turn off
		{

			%veh.unhideNode(lights_amberR_0);
			%veh.hideNode(lights_amberR_1);

		}
		else if(%direction == -1)	//Left side turn off
		{

			%veh.unhideNode(lights_amberL_0);
			%veh.hideNode(lights_amberL_1);

		}
		else //Hazard lights off
		{

			%veh.unhideNode(lights_amberR_0);
			%veh.hideNode(lights_amberR_1);

			%veh.unhideNode(lights_amberL_0);
			%veh.hideNode(lights_amberL_1);

		}
	}
		
	return %veh.turnSignalSchedule = %this.schedule(300, turnSignal, %veh, %direction);
}