datablock TSShapeConstructor(ImpalaDTS)
{
	baseShape  = "./shapes/Impala.dts";
	sequence0  = "./shapes/flc_frc.dsq flc_frc";
	sequence1  = "./shapes/flc_fro.dsq flc_fro";
	sequence2  = "./shapes/flo_frc.dsq flo_frc";
	sequence3  = "./shapes/flo_fro.dsq flo_fro";
	sequence4  = "./shapes/hc_tc.dsq hc_tc";
	sequence5  = "./shapes/hc_to.dsq hc_to";
	sequence6  = "./shapes/ho_tc.dsq ho_tc";
	sequence7  = "./shapes/ho_to.dsq ho_to";
};

datablock ParticleData(ImpaladenseShortTireParticle)
{
  dragCoefficient = 99;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 150;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = 0;
  spinRandomMax = 0;
  colors[0] = "0.1 0.1 0.1 0.5";
  colors[1] = "0.1 0.1 0.1 0";
  sizes[0] = 0.6;
  sizes[1] = 0.6;
  useInvAlpha = true;
};

datablock ParticleEmitterData(ImpaladenseShortTireEmitter)
{
  uiName = "";
  ejectionPeriodMS = 2;
  periodVarianceMS = 0;
  ejectionVelocity = 0;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "ImpaladenseShortTireParticle";
  useEmitterColors = true;
};

datablock fxLightData(ImpalaHeadLight)
{
	radius = 50;
	brightness = 4;
	color = "1 0.85 0.55 1";
	flareOn = false;
};

datablock WheeledVehicleData(Impalavehicle)
{
	category = "Vehicles";
	uiName = "Impala";
	dismountOffset[0] = "-3.5 0.5 1";
	dismountOffset[1] = "3.5 0.5 1";
	massCenter = "0 0.61 0.4";

	engineTorque = 2500;
	engineBrake = 1000;
	brakeTorque = 3500;
	maxWheelSpeed = 40;

	handsOnVehicle = 1;
	shiftBrickCarControls = 1;
	hasScriptedHeadlights = 1;
	mountedLightBotMount = 4;
	usesVehicleEditHelper = 1;
	storedColorScheme = 1;
	colorSchemeIdentifier = "Impala";

	numFactoryColorGroups = 3;

	numFactoryColors[0] = 15;
	factoryColor[0, 1] = "1C1C1C Regal Black";		//11
	factoryColor[0, 2] = "FFF4E5 Arctic White";				//15
	factoryColor[0, 3] = "5F87A9 Astro Blue";	//19
	factoryColor[0, 4] = "0A0A30 Midnight Blue";			//21
	factoryColor[0, 5] = "7A9083 Seafoam Green";	//22
	factoryColor[0, 6] = "063536 Verde Green";		//29 27322E
	factoryColor[0, 7] = "69A3AD Turquoise Mist";		//36
	factoryColor[0, 8] = "2C4656 Midnight Aqua"; 		//
	factoryColor[0, 9] = "4F181A Burgundy";	 	//49
	factoryColor[0, 10] = "880C0C Flame Red";	 	//54
	factoryColor[0, 11] = "BF9359 Sahara Mist"; 				//59
	factoryColor[0, 12] = "ADA396 Champagne Mist";		//61
	factoryColor[0, 13] = "D7C8BB Shell Beige";	 	//67
	factoryColor[0, 14] = "F2E096 Bamboo Cream"; 		//76
	factoryColor[0, 15] = "757171 Silver Cloud"; 			//78

	numFactoryColors[1] = 7;
	factoryColor[1, 1] = "DDD9CA White";
	factoryColor[1, 2] = "43697F Blue";
	factoryColor[1, 3] = "9C0000 Red";
	factoryColor[1, 4] = "7DA89A Turquoise";
	factoryColor[1, 5] = "49775D Green";
	factoryColor[1, 6] = "404040 Black";
	factoryColor[1, 7] = "C6B0A3 Bronze";

	numFactoryColors[2] = 1;
	factoryColor[2, 1] = "DDD9CA White";

	displayName = "";
	shapeFile = "./shapes/Impala.dts";
	emap = true;
	minMountDist = 3;

	rollForce = 0;
	yawForce = 0;
	pitchForce = 0;
	rotationalDrag = 1;

	rideable = true;
	lookUpLimit = 0.6;
	lookDownLimit = 0.5;
 
	numMountPoints = 4;
	mountThread[0] = "sit";
	mountThread[1] = "sit";
	mountThread[2] = "sit";
	mountThread[3] = "sit";


	paintable = true;

	maxDamage = 200.00;
	destroyedLevel = 400.00;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	maxSteeringAngle = 0.85;
	integration = 4;
	tireEmitter = ImpaladenseShortTireEmitter;

	useEyePoint = false;

	cameraRoll = false;
	cameraMaxDist = 10;
	cameraOffset = 3.5;
	cameraTilt = 0.25;

	cameraLag = 0.0;
	cameraDecay = 0.75;
	collisionTol = 0.1;
	contactTol = 0.1;

	defaultTire = ImpalaTire;
	defaultSpring = ImpalaSpring;

	numWheels = 4;

	mass = 300;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;
	softImpactSpeed = 10;
	hardImpactSpeed = 15;
	groundImpactMinSpeed = 10.0;

	steeringAutoReturn = true;
	steeringAutoReturnRate = 0.05;
	steeringAutoReturnMaxSpeed = 0.1;
	steeringUseStrafeSteering = true;
	steeringStrafeSteeringRate = 0.05;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
   

	damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

	damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

	numDmgEmitterAreas = 1;


	initialExplosionProjectile = vehicleExplosionProjectile;
	initialExplosionOffset = 0;

	burnTime = 4000;

	finalExplosionProjectile = vehicleFinalExplosionProjectile;
	finalExplosionOffset = 0.5;



	minRunOverSpeed    = 4;
	runOverDamageScale = 8;
	runOverPushScale   = 1.2;

	protectPassengersBurn   = false;
	protectPassengersRadius = true;
	protectPassengersDirect = false;
	
	isInteractive = true;
	iNumZones = 4;
	iZone[0] = "-5 -0.9 -0.8 -1.3 1.6 2.35";
	iZoneScript[0] = "door0Clicked";
	iZone[1] = "1.3 -0.9 -0.8 5 1.6 2.35";
	iZoneScript[1] = "door1Clicked";
	iZone[2] = "-1.3 1.7 0.7 1.1 5 2.0";
	iZoneScript[2] = "hoodClicked";
	iZone[3] = "-1.3 -5 0.4 1.5 -2.3 2.0";
	iZoneScript[3] = "trunkClicked";	
};