package ImpalaPackage
{
	function ImpalaVehicle::onAdd(%this, %veh)
	{
		Parent::onAdd(%this, %veh);

		%veh.spawnMountedLightBot(%this.mountedlightbotmount);

			
		%veh.doorsSide = "flc_frc";
		%veh.playthread(0, veh.doorsSide);
		%veh.doorsOther = "hc_tc";
		%veh.playthread(1, %veh.doorsOther);

		%veh.hidenode(headlights_white_1);
		%veh.hidenode(taillights_L_1);
		%veh.hidenode(taillights_R_1);
		%veh.hidenode(lights_amberR_1);
		%veh.hidenode(lights_amberL_1);
		%veh.hidenode(brakelights_red_1);
		%veh.hidenode(brakelights_red_2);
		%veh.hidenode(revlights_white_1);
		
		%veh.setWheelPowered(0, 0);
		%veh.setWheelPowered(1, 0);

		%veh.colorSchemeTarget = 0;

		%this.schedule(50, loadSpawnBrickAttributes, %veh);
	}

	function Impalavehicle::setDefaultBrickAttributes(%this, %veh)
	{
		%brick = %veh.spawnbrick;
		%ID = %this.colorSchemeIdentifier;

		%brick.numColorSchemeTargets[%ID] = 8;

		%a = getRandom(%this.numFactoryColors[0] - 1) + 1;
		// announce(%a);

		switch(%a)
		{
			case 1:
				%a = 1;
				%i1 = "3 6 7";
				%d = getWord(%i1, getRandom(0, getWordCount(%i1) - 1));
				if(getRandom() < 0.25)
					{
						%t1 = "2 9 10 11";
						%b = getWord(%t1, getRandom(0, getWordCount(%t1) - 1));
					}
			case 2:
				%a = 2;
				if(getRandom() < 0.25)
				{
					%t2 = "1 3 4 5 6 7 8 9 10 11 12 13 14 15";
					%b = getWord(%t2, getRandom(0, getWordCount(%t2) - 1));
					
					switch(%b)
					{
						case 1:
							%b = 1;
							%d = 6;
						case 3:
							%b = 3;
							%d = 2; 
						case 4:
							%b = 4;
							%d = 2;
						case 5:
							%b = 5;
							%d = 5;
						case 6:
							%b = 6;
							%d = 5;
						case 7:
							%b = 7;
							%d = 2;
						case 8:
							%b = 8;
							%d = 2;
						case 9:
							%b = 9;
							%d = 3;
						case 10:
							%b = 10;
							%d = 3;
						case 11:
							%b = 11;
							%d = 6;
						case 12:
							%b = 12;
							%d = 6;
						case 13:
							%b = 13;
							%d = 6;
						case 14:
							%b = 14;
							%d = 6;
						case 15:
							%b = 15;
							%d = 6;
					}
				}			
				else
				{
					%d = getRandom(%this.numFactoryColors[1] - 1) + 1;
				}
			case 3:
				%a = 3;	
				%i3 = "1 2 6";
				%d = getWord(%i3, getRandom(0, getWordCount(%i3) - 1));
				if(getRandom() < 0.25)
				{
					%t3 = "2 4";
					%b = getWord(%t3, getRandom(0, getWordCount(%t3) - 1));
				}				
			case 4:
				%a = 4;
				%i4 = "1 2 6 7";
				%d = getWord(%i4, getRandom(0, getWordCount(%i4) - 1));
				if(getRandom() < 0.25)
				{
					%t4 = "2 3";
					%b = getWord(%t4, getRandom(0, getWordCount(%t4) - 1));
				}				
			case 5:
				%a = 5;
				%i5 = "1 4 5 6";				
				%d = getWord(%i5, getRandom(0, getWordCount(%i5) - 1));
				if(getRandom() < 0.25)
				{
					%t5 = "2 7";
					%b = getWord(%t5, getRandom(0, getWordCount(%t5) - 1));
				}
			case 6:
				%a = 6;
				%i6 = "1 4 5 7";				
				%d = getWord(%i6, getRandom(0, getWordCount(%i6) - 1));	
				if(getRandom() < 0.25)
				{
					%b = 2;
				}
			case 7:
				%a = 7;
				%i7 = "1 2 4 6";				
				%d = getWord(%i7, getRandom(0, getWordCount(%i7) - 1));	
				if(getRandom() < 0.25)
				{
					%t7 = "2 8";
					%b = getWord(%t7, getRandom(0, getWordCount(%t7) - 1));
				}	
			case 8:
				%a = 8;
				%i8 = "1 2 4 5 6 7";				
				%d = getWord(%i8, getRandom(0, getWordCount(%i8) - 1));	
				if(getRandom() < 0.25)
				{
					%t8 = "2 7";
					%b = getWord(%t8, getRandom(0, getWordCount(%t8) - 1));
				}
			case 9:
				%a = 9;
				%i9 = "1 3 6 7";				
				%d = getWord(%i9, getRandom(0, getWordCount(%i9) - 1));	
				if(getRandom() < 0.25)
				{
					%t9 = "1 2";
					%b = getWord(%t9, getRandom(0, getWordCount(%t9) - 1));
				}
			case 10:
				%a = 10;
				%i10 = "1 3 6 7";				
				%d = getWord(%i10, getRandom(0, getWordCount(%i10) - 1));	
				if(getRandom() < 0.25)
				{
					%t10 = "1 2";
					%b = getWord(%t10, getRandom(0, getWordCount(%t10) - 1));
				}
			case 11:
				%a = 11;
				%i11 = "1 3 6 7";				
				%d = getWord(%i11, getRandom(0, getWordCount(%i11) - 1));	
				if(getRandom() < 0.25)
				{
					%t11 = "1 2";
					%b = getWord(%t11, getRandom(0, getWordCount(%t11) - 1));
				}
			case 12:
				%a = 12;
				%i12 = "2 3 6 7";				
				%d = getWord(%i12, getRandom(0, getWordCount(%i12) - 1));
				if(getRandom() < 0.25)
				{
					%t12 = "1 13";
					%b = getWord(%t12, getRandom(0, getWordCount(%t12) - 1));
				}
			case 13:
				%a = 13;
				%i13 = "2 3 6 7";				
				%d = getWord(%i13, getRandom(0, getWordCount(%i13) - 1));
				if(getRandom() < 0.25)
				{
					%t13 = "1 12";
					%b = getWord(%t13, getRandom(0, getWordCount(%t13) - 1));
				}
			case 14:
				%a = 14;
				%i14 = "1 3 6 7";				
				%d = getWord(%i14, getRandom(0, getWordCount(%i14) - 1));
				if(getRandom() < 0.25)
				{
					%t14 = "1 2";
					%b = getWord(%t14, getRandom(0, getWordCount(%t14) - 1));
				}					
			case 15:
				%a = 15;
				%i15 = "3 6 7";				
				%d = getWord(%i15, getRandom(0, getWordCount(%i15) - 1));
				if(getRandom() < 0.25)
				{
					%t15 = "1 2";
					%b = getWord(%t15, getRandom(0, getWordCount(%t15) - 1));
				}
		}
		

		%brick.colorSchemeName[%ID, 0] = "Base";
		%brick.colorSchemeFactoryColorGroup[%ID, 0] = 0;
		%brick.colorSchemeColor[%ID, 0] = getColorF(getWord(%this.factoryColor[0, %a], 0));
		// echo("exterior colour is");
		// echo(%a);


		%brick.colorSchemeName[%ID, 1] = "Roof";
		%brick.colorSchemeNodes[%ID, 1] = "Roof";
		%brick.colorSchemeFactoryColorGroup[%ID, 1] = 0;
		%brick.colorSchemeColor[%ID, 1] = getColorF(getWord(%this.factoryColor[0, %b], 0));
		// echo("roof colour is");
		// echo(%b);


		%brick.colorSchemeName[%ID, 2] = "Interior";
		%brick.colorSchemeNodes[%ID, 2] = "Interior LeftDoorInterior RightDoorInterior";
		%brick.colorSchemeFactoryColorGroup[%ID, 2] = 1;
		%brick.colorSchemeColor[%ID, 2] = getColorF(getWord(%this.factoryColor[1, %d], 0));
		// echo("interior colour is");
		// echo(%d);

		%brick.colorSchemeName[%ID, 3] = "Interior Parts";
		%brick.colorSchemeNodes[%ID, 3] = "Frontseats Backseats Steerwheel LeftDoorInteriorarm RightDoorInteriorarm Steerwheelrod";
		%brick.colorSchemeFactoryColorGroup[%ID, 3] = 2;
		%brick.colorSchemeColor[%ID, 3] = getColorF(getWord(%this.factoryColor[2, 1], 0));
		// echo("interior colour is");
		// echo(%d);

		%brick.colorSchemeName[%ID, 4] = "Trunk";
		%brick.colorSchemeNodes[%ID, 4] = "Trunk";
		%brick.colorSchemeFactoryColorGroup[%ID, 4] = 0;
		%brick.colorSchemeColor[%ID, 4] = getColorF(getWord(%this.factoryColor[0, %a], 0));
		// echo("exterior colour is");
		// echo(%d);

		%brick.colorSchemeName[%ID, 5] = "Hood";
		%brick.colorSchemeNodes[%ID, 5] = "Hood";
		%brick.colorSchemeFactoryColorGroup[%ID, 5] = 0;
		%brick.colorSchemeColor[%ID, 5] = getColorF(getWord(%this.factoryColor[0, %a], 0));
		// echo("exterior colour is");
		// echo(%d);

		%brick.colorSchemeName[%ID, 6] = "DoorL";
		%brick.colorSchemeNodes[%ID, 6] = "LeftDoor";
		%brick.colorSchemeFactoryColorGroup[%ID, 6] = 0;
		%brick.colorSchemeColor[%ID, 6] = getColorF(getWord(%this.factoryColor[0, %a], 0));
		// echo("exterior colour is");
		// echo(%d);

		%brick.colorSchemeName[%ID, 7] = "DoorR";
		%brick.colorSchemeNodes[%ID, 7] = "RightDoor";
		%brick.colorSchemeFactoryColorGroup[%ID, 7] = 0;
		%brick.colorSchemeColor[%ID, 7] = getColorF(getWord(%this.factoryColor[0, %a], 0));
		// echo("exterior colour is");
		// echo(%d);

		// announce(%brick.colorSchemeColor[%ID, 0]);

		%brick.carAttributesSet[%ID] = true;

		%this.schedule(50, loadSpawnBrickAttributes, %veh);

		return;
	}

	function Impalavehicle::loadSpawnBrickAttributes(%this, %veh)
	{
		// announce("load attributes " @ %this);
		if(!isObject(%veh))
    		return;
		%brick = %veh.spawnbrick;
		%ID = %this.colorSchemeIdentifier;

		if(!%brick.carAttributesSet[%ID])
		{
			// %brick.roofopen[%ID] = 1; //convertibles always start open
			// %brick.bodytype[%ID] = getRandom() < 0.5; //50% chance to be a coupe
			// if(getRandom() < 0.2)
			// {
				// %brick.bodytype[%ID] = 2; //20% chance to be a convertible
			// }

			// //return %this.schedule(500, setDefaultBrickAttributes, %veh);
			%this.setDefaultBrickAttributes(%veh);
		}

		%veh.bodytype = %brick.bodytype[%ID];
		// %veh.rooftype = %brick.rooftype[%ID];
		%veh.roofopen = %brick.roofopen[%ID];

		%veh.numColorSchemeTargets = %brick.numColorSchemeTargets[%ID];

		for(%i = 0; %i < %brick.numColorSchemeTargets[%ID]; %i++)
		{
			//announce(%brick.colorSchemeName[%this, %i]);
			%veh.colorSchemeName[%i] = %brick.colorSchemeName[%ID, %i];
			if(%i > 0) 
			{
				%veh.colorSchemeNodes[%i] = %brick.colorSchemeNodes[%ID, %i];
			}
			%veh.colorSchemeFactoryColorGroup[%i] = %brick.colorSchemeFactoryColorGroup[%ID, %i];
			%veh.colorSchemeColor[%i] = %brick.colorSchemeColor[%ID, %i];
		}
		
		switch(%brick.wheelCurrent[%ID])
		{
			case 0:
				%veh.setWheelTire(0, ImpalaTire);
				%veh.setWheelTire(1, ImpalaTire);
				%veh.setWheelTire(2, ImpalaTire);
				%veh.setWheelTire(3, ImpalaTire);

			case 1:
				%veh.setWheelTire(0, RoadTire);
				%veh.setWheelTire(1, RoadTire);
				%veh.setWheelTire(2, RoadTire);
				%veh.setWheelTire(3, RoadTire);

			case 2:
				%veh.setWheelTire(0, DDishTire);
				%veh.setWheelTire(1, DDishTire);
				%veh.setWheelTire(2, DDishTire);
				%veh.setWheelTire(3, DDishTire);

			case 3:
				%veh.setWheelTire(0, KeyStoneTire);
				%veh.setWheelTire(1, KeyStoneTire);
				%veh.setWheelTire(2, KeyStoneTire);
				%veh.setWheelTire(3, KeyStoneTire);
			case 4:
				%veh.setWheelTire(0, CragarTire);
				%veh.setWheelTire(1, CragarTire);
				%veh.setWheelTire(2, CragarTire);
				%veh.setWheelTire(3, CragarTire);

			case 5:
				%veh.setWheelTire(0, ClassicTire);
				%veh.setWheelTire(1, ClassicTire);
				%veh.setWheelTire(2, ClassicTire);
				%veh.setWheelTire(3, ClassicTire);
			case 6:
				%veh.setWheelTire(0, MercuryTire);
				%veh.setWheelTire(1, MercuryTire);
				%veh.setWheelTire(2, MercuryTire);
				%veh.setWheelTire(3, MercuryTire);
			case 7:
				%veh.setWheelTire(0, TrainTire);
				%veh.setWheelTire(1, TrainTire);
				%veh.setWheelTire(2, TrainTire);
				%veh.setWheelTire(3, TrainTire);
			case 8:
				%veh.setWheelTire(0, MagnumTire);
				%veh.setWheelTire(1, MagnumTire);
				%veh.setWheelTire(2, MagnumTire);
				%veh.setWheelTire(3, MagnumTire);

		}

		//%this.applyParts(%veh); //Apply all hidden/unhidden nodes
		
		%veh.colorSchemeTargetRestore = %veh.colorSchemeTarget;
		%veh.colorSchemeTarget = 0;
		%veh.setNodeColor("ALL", %veh.colorSchemeColor[0]); //Reapply current color to cause changes
		%veh.colorSchemeTarget = %veh.colorSchemeTargetRestore;
	}
};
activatepackage(ImpalaPackage);

package onDriverEnterPackage
{
	function armor::onMount(%this, %obj, %vehicle, %node)
	{
		Parent::onMount(%this, %obj, %vehicle, %node);
		
		if(%node == 0 && isObject(%vehicle) && isFunction(%vehicle.dataBlock, onDriverEnter))
			%vehicle.dataBlock.onDriverEnter(%vehicle, %obj);
	}

};
activatePackage(onDriverEnterPackage);

function ImpalaVehicle::onDriverEnter(%this, %veh)
{   
	//onDriverEnter and onDriverLeave both are called many times (up to 14) for some reason.
	// The hasDriver variable makes it so these things are done only one time each.
	if(!%veh.hasDriver)
	{
		%veh.hasDriver = 1;
		
		%this.headlights(%veh, "restore");
		
		%this.SpeedCheck(%veh);
	}
}

function ImpalaVehicle::onDriverLeave(%this, %veh)
{       
	if(!isObject(%veh)) 
		return;
	else
	{
		if(%veh.hasDriver)
		{
			%veh.hasDriver = 0;

			if(%veh.braking)
			{
				%veh.braking = 0;
				%veh.hidenode(brakelights_red_2);

				if(%veh.headlightState > 0)
				{
					%veh.unhidenode(brakelights_red_1);
				}
				else
				{
					%veh.unhidenode(brakelights_red_0);
				}
			}
			
			%veh.reversing = 0;
			%veh.unhidenode(revlights_white_0);
			%veh.hidenode(revlights_white_1);

			cancel(%veh.SpeedCheckSchedule);
			if(%veh.signal != -11) %this.turnSignal(%veh, 0);
			%veh.mountedLightBot[%this.mountedlightbotmount].setMountedLight(none);
		}
	}
}

function ImpalaVehicle::onRemove(%this, %veh)
{
	%veh.removeMountedLightBot(%this.mountedlightbotmount);
}

function ImpalaVehicle::SpeedCheck(%this, %veh)
{
    if(isEventPending(%veh.SpeedCheckSchedule)) return;
    if(!isObject(%veh)) return;
	
    %veh.speed = vectorDot(%veh.getVelocity(), %veh.getForwardVector());
	
    if(!%veh.reversing && %veh.speed <= -3)
    {
        %veh.hidenode(revlights_white_0);
        %veh.unhidenode(revlights_white_1);
        %veh.reversing = 1;
    }
    else if(%veh.reversing && %veh.speed > -0.1)
    {
        %veh.unhidenode(revlights_white_0);
        %veh.hidenode(revlights_white_1);
        %veh.reversing = 0;
    }
		// %veh.spawnbrick.carAttributesSet[%this.colorSchemeIdentifier] = false;
		 //%this.loadSpawnBrickAttributes(%veh);
	
    %veh.SpeedCheckSchedule = %this.schedule(250, "SpeedCheck", %veh);
}